# 
# Try to find CUDPP  library  
# (see http://gpgpu.org/)
# Once run this will define: 
# 
# CUDPP_FOUND
# CUDPP_INCLUDE_DIR 
# CUDPP_LIBRARIES
# CUDPP_LINK_DIRECTORIES
#

FIND_PATH(CUDPP_INCLUDE_DIR cudpp.h
   ${CUDPP_ROOT_DIR}/cudpp/include
   ${CUDPP_ROOT_DIR}/include
)

FIND_LIBRARY(CUDPP_LIBRARY
  NAMES cudpp cudpp${CMAKE_SIZEOF_VOID_P}
  PATHS 
     ${CUDPP_ROOT_DIR}/lib
)

IF(CUDPP_LIBRARY)
  IF (CUDPP_INCLUDE_DIR)

    # OK, found all we need
    SET(CUDPP_FOUND TRUE)
    GET_FILENAME_COMPONENT(CUDPP_LINK_DIRECTORIES ${CUDPP_LIBRARY} PATH)
    
  ELSE (CUDPP_INCLUDE_DIR)
    MESSAGE("CUDPP include dir not found. Set CUDPP_ROOT_DIR to find it.")
  ENDIF(CUDPP_INCLUDE_DIR)
ELSE(CUDPP_LIBRARY)
  MESSAGE("CUDPP lib not found. Set CUDPP_ROOT_DIR to find it.")
ENDIF(CUDPP_LIBRARY)


MARK_AS_ADVANCED(
  CUDPP_INCLUDE_DIR
  CUDPP_LIBRARY
  CUDPP_LINK_DIRECTORIES
)
