#ifndef _HW_THREAD_H
#define _HW_THREAD_H

typedef struct HWThreadT *HWThread;
typedef int (*HWRunFunction)(HWThread thread, void *ctx, int block, void *attr);
typedef int (*HWFreeFunction)(void *ctx);

#include "hw_sched.h"

enum HWThreadStatusT {
    HW_THREAD_STATUS_IDLE = 0,
    HW_THREAD_STATUS_RUNNING = 1,
    HW_THREAD_STATUS_DONE = 2,
    HW_THREAD_STATUS_INIT = 3
};
typedef enum HWThreadStatusT HWThreadStatus;


#ifndef HW_HIDE_DETAILS
#include <glib.h>
struct HWThreadT {
    int thread_id;
    HWSched sched;
    
    GThread *thread;
    
    void *hwctx;
    HWRunFunction *run;
    HWFreeFunction free;
    
    HWThreadStatus status;

    void *data;			/**< Per-thread data storage, will be free'd if set */
};
typedef struct HWThreadT HWThreadS;
#endif /* HW_HIDE_DETAILS */

# ifdef __cplusplus
extern "C" {
# endif

HWThread hw_thread_create(HWSched sched, int thread_id, void *hwctx, HWRunFunction *run_func, HWFreeFunction free_func);
void hw_thread_destroy(HWThread ctx);

# ifdef __cplusplus
}
# endif


#endif /* _HW_THREAD_H */
